/**
 * Modern Albufeira Prolog Interpreter
 *
 * Warranty & Liability
 * To the extent permitted by applicable law and unless explicitly
 * otherwise agreed upon, XLOG Technologies AG makes no warranties
 * regarding the provided information. XLOG Technologies AG assumes
 * no liability that any problems might be solved with the information
 * provided by XLOG Technologies AG.
 *
 * Rights & License
 * All industrial property rights regarding the information - copyright
 * and patent rights in particular - are the sole property of XLOG
 * Technologies AG. If the company was not the originator of some
 * excerpts, XLOG Technologies AG has at least obtained the right to
 * reproduce, change and translate the information.
 *
 * Reproduction is restricted to the whole unaltered document. Reproduction
 * of the information is only allowed for non-commercial uses. Selling,
 * giving away or letting of the execution of the library is prohibited.
 * The library can be distributed as part of your applications and libraries
 * for execution provided this comment remains unchanged.
 *
 * Restrictions
 * Only to be distributed with programs that add significant and primary
 * functionality to the library. Not to be distributed with additional
 * software intended to replace any components of the library.
 *
 * Trademarks
 * Jekejeke is a registered trademark of XLOG Technologies AG.
 */

import {add, make_check, exec_unify, fs, real_time,
    norm_smallint, norm_float, get_gc_enter,
    get_gc_time, get_gc_maxinfs, gc_major
} from "../../nova/core.mjs";

/*********************************************************************/
/* sys_stat_map/1                                                       */
/*********************************************************************/

/**
 * sys_stat_map(M): internal only
 * The built-in succeeds in W with the statistics map.
 */
function test_sys_stat_map(args) {
    let res = {};
    res.wall = norm_smallint(Date.now());
    res.time = norm_float(real_time());
    res.maxinfs = norm_smallint(get_gc_maxinfs());
    res.calls = norm_smallint(get_gc_enter());
    res.gctime = norm_float(get_gc_time());
    if (fs !== undefined) {
        res.used = norm_smallint(process.memoryUsage().heapUsed);
    } else if (performance.memory !== undefined) {
        res.used = norm_smallint(performance.memory.usedJSHeapSize);
    } else {
        res.used = 0;
    }
    return exec_unify(args[0], res);
}

/**
 * garbage_collect: internal only
 * The built-in succeeds in attempting a garbage colection.
 */
function test_garbage_collect(args) {
    gc_major();
    if (fs !== 0) {
        // --expose-gc
        global.gc();
    } else {
        // --js-flags="--expose-gc"
        window.gc();
    }
    return true
}

/*********************************************************************/
/* Stat Lib Init                                                     */
/*********************************************************************/

export function main() {
    add("sys_stat_map", 1, make_check(test_sys_stat_map));
    add("garbage_collect", 0, make_check(test_garbage_collect));
}